// $Id: ruler.cc,v 1.22 2002/06/15 13:22:14 christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *  Copyright (C) 1999-2000  Adolf Petig GmbH & Co. KG, written by Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "widget.hh"

class Gtk_Ruler : public Gtk_Widget
{public:
	typedef Gtk_Widget Parent;
	virtual const std::string TypeName(const Widget &w) const;
	virtual const std::string IncludeName(const Widget &w) const;
	Gtk_Ruler();
	virtual void Configure(const Widget &w, CxxFile &f,const std::string &instance) const;
	virtual bool NeedExplicitCtor(const Widget &w) const
	{  return false; }
	virtual void ConstructionArgs(Widget const &w, CxxFile &f) const
	{  f.FunctionArg(); }
};

static Gtk_Ruler Gtk_Ruler;

const std::string Gtk_Ruler::TypeName(const Widget &w) const
{  return GtkPrefix()+(w.Class()[3]=='H' ?"HRuler":"VRuler");
}

const std::string Gtk_Ruler::IncludeName(const Widget &w) const
{  return Configuration.GtkmmIncludePath()+"ruler.h";
}

Gtk_Ruler::Gtk_Ruler()
{  Writer["GtkHRuler"]=this;
   Writer["GtkVRuler"]=this;
}

void Gtk_Ruler::Configure(const Widget &w, CxxFile &f,const std::string &instance) const
{  Parent::Configure(w,f,instance);
   WriteEnumPropertyNS(w,f,instance, "metric");

   float lower=w.getFloatProperty("lower",0);
   float upper=w.getFloatProperty("upper",10);
   float position=w.getFloatProperty("position",5);
   float max_size=w.getFloatProperty("max_size",10);
   f.Statement() << instance << "set_range(" << lower << ", " << upper << ", "
     << position << ", " << max_size << ')';
}
